SystemOrganization addCategory: #'JQWidgetBox-FullCalendar-Dev-Example'!

WASession subclass: #JQFullCalendarExampleSession
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-FullCalendar-Dev-Example'!

!JQFullCalendarExampleSession methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/22/2010 10:30'!
events 

	^events ! !

!JQFullCalendarExampleSession methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/22/2010 10:30'!
events: aCollectionOfEvents
	events:=aCollectionOfEvents ! !

!JQFullCalendarExampleSession methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/22/2010 10:44'!
initialize 

	super initialize.
events := OrderedCollection new.
	events
		add:
			((JQFullCalendarEvent new)
				title: 'Event 1';
				start:(DateAndTime now - 2 days)).
	events
		add:
			((JQFullCalendarEvent new)
				title: 'Event 2';
				start: (DateAndTime now + 2 days);
				end: (DateAndTime now + 2 days+2 hours)).
	events
		add:
			((JQFullCalendarEvent new)
				title: 'Event 3';
				start: DateAndTime now).! !

JQWidgetExample subclass: #JQFullCalendarExample
	instanceVariableNames: 'events calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-FullCalendar-Dev-Example'!

!JQFullCalendarExample commentStamp: '<historical>' prior: 0!
So this class should highlight some of the features of FullCalendar (http://arshaw.com/fullcalendar/).

You can set all of the initialization options.  You can create an event by clicking on the calendar in the month view, or by selecting a range in the week or day calendar.  You can edit and event by clicking on it. You can extend, shorten, and move an event to a different time.  The collection 'events' is re-initialized each time the calendar is drawn.  You could set it to a session variable to keep your changes between ajax reloads of the calendar.   


!

!JQFullCalendarExample classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:32'!
description
	^ 'JQuery Full Calendar'! !

!JQFullCalendarExample classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/22/2010 10:42'!
initialize 
"
JQFullCalendarExample initialize
"

	|app|
app:=	(WAAdmin register: self asApplicationAt: 'jquery-widgets/' , self shortName).

(app filters detect: #isExceptionFilter ) configuration at: #exceptionHandler put: WADebugErrorHandler .
	app 
		preferenceAt: #sessionClass put: JQFullCalendarExampleSession;
				addLibrary: JQDevelopmentLibrary;
			addLibrary: JQUiDevelopmentLibrary;
			addLibrary: JQWidgetBoxDeploymentLibrary! !

!JQFullCalendarExample classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:32'!
shortName
	^'fullcalendar'! !

!JQFullCalendarExample methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/25/2010 15:39'!
calendar
	^ calendar! !

!JQFullCalendarExample methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/25/2010 15:39'!
calendar: anObject
	calendar := anObject! !

!JQFullCalendarExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 14:29'!
events
	^events! !

!JQFullCalendarExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 14:29'!
events: aCollectionOfEvents
	events:=aCollectionOfEvents ! !

!JQFullCalendarExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 14:18'!
initialize
	super initialize .
	calendar:=JQFullCalendarExampleCalendar new.! !

!JQFullCalendarExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:55'!
renderContentOn: html
html div
	id:'calendar-container';
	with:[events isNil ifFalse:[calendar events: events].
		
		html render: calendar]! !

!JQFullCalendarExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 8/7/2011 13:23'!
updateRoot: root
	super updateRoot: root.
		root stylesheet
		url: 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.14/themes/base/jquery-ui.css'.

		root stylesheet url: self library  / #fullcalendarCss	.
	root javascript url: self library / #fullcalendarminJs.
	! !

WAComponent subclass: #JQFullCalendarEventEditor
	instanceVariableNames: 'event edit events editedEvent timeList calendar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-FullCalendar-Dev-Example'!

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
copyEvent
	editedEvent :=event copy.! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/22/2010 21:01'!
delete: anEvent

	events remove: anEvent.! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
edit
	^ edit! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
edit: anObject
	edit := anObject! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
editedEvent
	^ editedEvent! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
editedEvent: anObject
	editedEvent := anObject! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
event
	^ event! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
event: anObject
	event := anObject! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
events
	^ events! !

!JQFullCalendarEventEditor methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
events: anObject
	events := anObject! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:47'!
renderContentOn: html
	(html div)
		id: 'event-editor';
		
		with: [ 
					edit
						ifTrue: [ 
							self copyEvent.
							(html heading)
								level3;
								with: 'Edit ' , event title.
									self renderEditForm: html]
						ifFalse: [ 
							(html heading)
								level3;
								with: 'Create An Event' .
									self renderCreateForm: html].
				 ]! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 8/6/2010 14:58'!
renderCopy: html

(html anchor)
	script: html jQuery this button;
						onClick:
								((html jQuery ajax)
										
										callback:[events add: event copy];
										script: [ :s | 
													s << (s jQuery id: 'eventEditor') dialog close.
												s<<(s jQuery id:'calendar-container') replaceWith: [:h | 
													calendar:=JQFullCalendarExampleCalendar new events: events.
													h render: calendar.]]);
						url:'#copy' , event title ;
						with: 'Copy ' , event title ! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
renderCreateForm: html
|id startDay startTime endDay endTime|
html form
	id:'event-details';
	with:[
						html div
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'Start Time'.	
							(html select)
								id: id;
								list: self timeList ;
								selected:(event start ) asTime;
								callback:[:val | startTime:=val].
							html hiddenInput 
									callback:[event start:(DateAndTime year: event start year  day:  event start day hour: startTime hour minute: startTime minutes second: startTime seconds )]	
								
								].
						html div
						id:'endtime';
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'End Time'.			
							(html select)
								id: id;
								list: self timeList;
								selected:((event end )asTime );
								callback:[:val | endTime:=val].
								html hiddenInput 
									callback:[event end:(DateAndTime year: event end year  day:  event end day hour: endTime hour minute: endTime minutes second: endTime seconds )]].
						html div
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'Title'.
							(html textInput)
								id: id;
								on: #title of: event ].	
		
							html hiddenInput 
								callback: [self saveNew]].! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 8/6/2010 14:58'!
renderDelete: html

(html anchor)
	script: html jQuery this button;
						onClick:
								((html jQuery ajax)
										confirm: ' Are you sure you want to delete ' , event title , '?';
										callback:[self delete: event];
										script: [ :s | 
													s << (s jQuery id: 'eventEditor') dialog close.
												s<<(s jQuery id:'calendar-container') replaceWith: [:h | 
													calendar:=JQFullCalendarExampleCalendar  new events: events.
													h render: calendar.]]);
						url:'#del' , event title ;
						with: 'Delete ' , event title ! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
renderEditForm: html
|id startDay startTime endDay endTime|
html form
	id:'event-details';
	with:[
						html div
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'Start Time'.	
							(html select)
								id: id;
								list: self timeList;
								selected:(event start ) asTime;
								callback:[:val | startTime:=val].
							html hiddenInput 
									callback:[editedEvent start:(DateAndTime year: event start year  day:  event start day hour: startTime hour minute: startTime minutes second: startTime seconds )]	
								
								].
						html div
						id:'endtime';
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'End Time'.			
							(html select)
								id: id;
								list: (self timeList);
								selected:((event end )asTime );
								callback:[:val | endTime:=val].
								html hiddenInput 
									callback:[editedEvent end:(DateAndTime year: event end year  day:  event end day hour: endTime hour minute: endTime minutes second: endTime seconds )]].
						html div
						with: [ 
							(html label)
								for: (id:=html nextId);
								with: 'Title'.
							(html textInput)
								id: id;
								on: #title of: editedEvent  ].	
		self renderCopy:html.
		
		self renderDelete:html.
							html hiddenInput 
								callback: [self replace]].! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
renderEndTime: html
|id endDay endTime|
(html label)
								for: (id:=html nextId);
								with: 'End Time'.			
							(html select)
								id: id;
								list: (self timeList);
								selected:((event end )asTime );
								callback:[:val | endTime:=val].
								html hiddenInput 
									callback:[event end:(DateAndTime year: event end year  day:  event end day hour: endTime hour minute: endTime minutes second: endTime seconds )]! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
replace

	events remove:event.
	events add: editedEvent ! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
saveNew

	events add: event! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 7/20/2010 13:29'!
timeList
	|x|
	x:=OrderedCollection new.
	(event start midnight to: event end midnight + 1 day) every: 30 minutes do: [:each |x add: (each asTime) ].
	^x! !

!JQFullCalendarEventEditor methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/21/2010 21:00'!
timeList: aCollectionOfTimes
	timeList :=aCollectionOfTimes ! !

WAComponent subclass: #JQFullCalendarExampleCalendar
	instanceVariableNames: 'eventEditor events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-FullCalendar-Dev-Example'!

!JQFullCalendarExampleCalendar commentStamp: '<historical>' prior: 0!
You need to manually run the class side initialize method after loading this package.  !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:30'!
events
	^events! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:30'!
events: aCollectionOfEvents
	events:=aCollectionOfEvents ! !

!JQFullCalendarExampleCalendar methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/25/2010 15:33'!
header
|head|
	head:=Dictionary new.
head at:'left' put:'prev,today,next'.
head at:'center' put:'title'.
head at:'right' put:'month,agendaWeek,agendaDay'.
^head! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 8/7/2011 13:22'!
renderCalendar: html
	
	self session events do: [ :each | each id: html nextId ].
	(html div)
		id: 'calendar';
		script:
				((html jQuery this fullCalendar)
						theme: true;
						selectable: true;
						selectHelper: true;
						defaultView: 'agendaWeek';
						unselectCancel: '.event-editor';
						collectionOfEvents: self session events;
						header: self header;
						onEventClick:
								(html jQuery id: 'eventEditor') dialog open
										,
											((html jQuery ajax)
												callback: [ :anEventId | self setEventToEdit: anEventId ] json: (JSStream on: 'calEvent.id');
												script: [ :s | s << (s jQuery id: 'event-editor') replaceWith: [ :h | h render: eventEditor ] ]);
						onEventDrop:
								(html jQuery ajax
										callback: [ :eventData | self updateEventStart: eventData ]
										json: (JSStream on: 'new Array(event.id,dayDelta,minuteDelta,allDay)'));
						onEventResize:
								(html jQuery ajax
										callback: [ :eventData | self updateEventEnd: eventData ]
										json: (JSStream on: 'new Array(event.id,dayDelta,minuteDelta)'));
						onSelect:
								(html jQuery id: 'eventEditor') dialog open
										,
											((html jQuery ajax)
												callback: [ :newEventData | self setEventToCreate: newEventData ]
													json: (JSStream on: 'new Array(startDate,endDate,allDay)');
												script: [ :s | s << (s jQuery id: 'event-editor') replaceWith: [ :h | h render: eventEditor ] ]))! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:33'!
renderContentOn: html
html paragraph:'Click on the calendar below to create an event.  On the day and week view you can select an area which will create an event that covers the selected timespan.  You can click on an event to edit it. '.
self renderCalendar: html .
self renderEventEditorDialog: html.! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:33'!
renderEventEditorDialog: html
	(html div)
		id: 'eventEditor';

		script:
				((html jQuery new dialog)
						title: 'Event Editor';
						autoOpen: false;
						modal: true;
						width:350;
						addButton: 'Save & Close'
							do:
								((html jQuery ajax)
										serializeForm: (html jQuery id: 'event-details');
										script: [ :s | 
													s << (s jQuery id: 'eventEditor') dialog close.
													
													s << (s jQuery id: 'calendar') replaceWith: [ :h | self renderCalendar: h ].
												 ]);
						addButton: 'Close Without Saving' do: html jQuery this dialog close);
		with: [ html div id: 'event-editor' ]! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 8/6/2010 14:05'!
setEventToCreate: newEventData
	| aNewEvent |
	aNewEvent := (JQFullCalendarEvent new)
		start: newEventData first asDateAndTime;
		end: newEventData second asDateAndTime;
		allDay: newEventData third = 'true'.
	eventEditor := JQFullCalendarEventEditor  new.
	^ eventEditor
		event: aNewEvent;
		events: self session events;
		edit: false! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:40'!
setEventToEdit: anEventId
	| anEvent |
	anEvent := (self session events select: [ :each | each id = anEventId ]) first.
	eventEditor := JQFullCalendarEventEditor  new.
	^ eventEditor
		event: anEvent;
		events: self session events;
		edit: true! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:33'!
updateEventEnd: eventData
	| anEvent |
	anEvent := (self session events select: [ :each | each id = eventData first ]) first.
	anEvent end: anEvent end + eventData second asNumber days.
	anEvent end: anEvent end + eventData third asNumber minutes.
		self session events remove: (self session events select: [ :each | each id = eventData first ]) first.
	self session events add: anEvent ! !

!JQFullCalendarExampleCalendar methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2010 15:33'!
updateEventStart: eventData
	| anEvent |
	anEvent := (self session events select: [ :each | each id = eventData first ]) first copy.
	anEvent start: anEvent start + eventData second asNumber days + eventData third asNumber minutes.
	anEvent end: anEvent end + eventData second asNumber days + eventData third asNumber minutes.

	self session events remove: (self session events select: [ :each | each id = eventData first ]) first.
	self session events add: anEvent ! !
JQFullCalendarExample initialize!
